View a markdown version of this page

AgentCore ゲートウェイでツールを呼び出す - Amazon Bedrock AgentCore

翻訳は機械翻訳により提供されています。提供された翻訳内容と英語版の間で齟齬、不一致または矛盾がある場合、英語版が優先します。

AgentCore ゲートウェイでツールを呼び出す

特定のツールを呼び出すには、ゲートウェイの MCP エンドポイントに POST リクエストを行います。をリクエスト本文の メソッドtools/callとして、ツールの名前とその引数とともに指定します。リクエスト形式は MCP プロトコルのバージョンによって異なります。

例
2025-11-25 and earlier
POST /mcp HTTP/1.1 Host: ${GatewayEndpoint} Accept: application/json, text/event-stream Content-Type: application/json Authorization: ${Authorization header} MCP-Protocol-Version: ${McpProtocolVersion} ${RequestBody}
2026-07-28

バージョン では2026-07-28、各リクエストは MCP-Protocol-Versionヘッダー、 Mcp-Methodおよび Mcp-Name request-metadata ヘッダー、および本文_metaのバージョンフィールドを保持します。

POST /mcp HTTP/1.1 Host: ${GatewayEndpoint} Accept: application/json, text/event-stream Content-Type: application/json Authorization: ${Authorization header} MCP-Protocol-Version: 2026-07-28 Mcp-Method: tools/call Mcp-Name: ${ToolName} ${RequestBody}
注記

ゲートウェイは、protocolConfiguration.mcp設定の supportedVersionsフィールドにリストされている MCP プロトコルバージョンのみを受け入れます。バージョン を使用するには2026-07-28、ゲートウェイに supportedVersionsが含まれていることを確認します。サポートされているバージョンは、UpdateGateway API を使用して変更できます。

以下の値を置き換えます:

レスポンスは、ツールから返されたコンテンツと関連するメタデータを返します。

ツールを呼び出すためのコードサンプル

ゲートウェイでツールを呼び出す例を表示するには、次のいずれかの方法を選択します。

例
curl (2025-11-25 and earlier)

次の curl リクエストは、ID のゲートウェイsearchProductsを介して というツールを呼び出すリクエストの例を示していますmygateway-abcdefghij。MCP-Protocol-Version ヘッダーをゲートウェイがサポートするバージョンに設定します。

curl -X POST \ https://mygateway-abcdefghij.gateway.bedrock-agentcore.us-west-2.amazonaws.com/mcp \ -H "Accept: application/json, text/event-stream" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "MCP-Protocol-Version: 2025-11-25" \ -d '{ "jsonrpc": "2.0", "id": "invoke-tool-request", "method": "tools/call", "params": { "name": "searchProducts", "arguments": { "query": "wireless headphones", "category": "Electronics", "maxResults": 2, "priceRange": { "min": 50.00, "max": 200.00 } } } }'
curl (2026-07-28)

バージョン では2026-07-28、本文に Mcp-Methodおよび Mcp-Name request-metadata ヘッダーと_metaバージョンフィールドを含めます。MCP-Protocol-Version ヘッダーは と一致する必要があります_meta.io.modelcontextprotocol/protocolVersion。ゲートウェイの には が含まれているsupportedVersions必要があります2026-07-28。

curl -X POST \ https://mygateway-abcdefghij.gateway.bedrock-agentcore.us-west-2.amazonaws.com/mcp \ -H "Accept: application/json, text/event-stream" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \ -H "MCP-Protocol-Version: 2026-07-28" \ -H "Mcp-Method: tools/call" \ -H "Mcp-Name: searchProducts" \ -d '{ "jsonrpc": "2.0", "id": "invoke-tool-request", "method": "tools/call", "params": { "name": "searchProducts", "arguments": { "query": "wireless headphones", "category": "Electronics", "maxResults": 2, "priceRange": { "min": 50.00, "max": 200.00 } }, "_meta": { "io.modelcontextprotocol/protocolVersion": "2026-07-28", "io.modelcontextprotocol/clientInfo": { "name": "my-agent", "version": "1.0.0" }, "io.modelcontextprotocol/clientCapabilities": {} } } }'
Python requests package (2025-11-25 and earlier)

MCP-Protocol-Version ヘッダーをゲートウェイがサポートするバージョンに設定します。

import requests import json def call_tool(gateway_url, access_token, tool_name, arguments): headers = { "Accept": "application/json, text/event-stream", "Content-Type": "application/json", "Authorization": f"Bearer {access_token}", "MCP-Protocol-Version": "2025-11-25" } payload = { "jsonrpc": "2.0", "id": "call-tool-request", "method": "tools/call", "params": { "name": tool_name, "arguments": arguments } } response = requests.post(gateway_url, headers=headers, json=payload) return response.json() # Example usage gateway_url = "https://${GatewayEndpoint}/mcp" # Replace with your actual gateway endpoint access_token = "${AccessToken}" # Replace with your actual access token result = call_tool( gateway_url, access_token, "openapi-target-1___get_orders_byId", # Replace with <{TargetId}__{ToolName}> {"orderId": "ORD-12345-67890", "customerId": "CUST-98765"} ) print(json.dumps(result, indent=2))
Python requests package (2026-07-28)

バージョン では2026-07-28、本文に Mcp-Methodおよび Mcp-Name request-metadata ヘッダーと_metaバージョンフィールドを含めます。MCP-Protocol-Version ヘッダーは と一致する必要があります_meta.io.modelcontextprotocol/protocolVersion。ゲートウェイの には が含まれているsupportedVersions必要があります2026-07-28。

import requests import json def call_tool(gateway_url, access_token, tool_name, arguments): headers = { "Accept": "application/json, text/event-stream", "Content-Type": "application/json", "Authorization": f"Bearer {access_token}", "MCP-Protocol-Version": "2026-07-28", "Mcp-Method": "tools/call", "Mcp-Name": tool_name } payload = { "jsonrpc": "2.0", "id": "call-tool-request", "method": "tools/call", "params": { "name": tool_name, "arguments": arguments, "_meta": { "io.modelcontextprotocol/protocolVersion": "2026-07-28", "io.modelcontextprotocol/clientInfo": {"name": "my-agent", "version": "1.0.0"}, "io.modelcontextprotocol/clientCapabilities": {} } } } response = requests.post(gateway_url, headers=headers, json=payload) return response.json() # Example usage gateway_url = "https://${GatewayEndpoint}/mcp" # Replace with your actual gateway endpoint access_token = "${AccessToken}" # Replace with your actual access token result = call_tool( gateway_url, access_token, "openapi-target-1___get_orders_byId", # Replace with <{TargetId}__{ToolName}> {"orderId": "ORD-12345-67890", "customerId": "CUST-98765"} ) print(json.dumps(result, indent=2))
MCP Client
from mcp import ClientSession from mcp.client.streamable_http import streamablehttp_client import asyncio async def execute_mcp( url, token, tool_params, headers=None ): default_headers = { "Authorization": f"Bearer {token}" } headers = {**default_headers, **(headers or {})} async with streamablehttp_client( url=url, headers=headers, ) as ( read_stream, write_stream, callA, ): async with ClientSession(read_stream, write_stream) as session: # 1. Perform initialization handshake print("Initializing MCP...") _init_response = await session.initialize() print(f"MCP Server Initialize successful! - {_init_response}") # 2. Call specific tool print(f"Calling tool: {tool_params['name']}") tool_response = await session.call_tool( name=tool_params['name'], arguments=tool_params['arguments'] ) print(f"Tool response: {tool_response}") return tool_response async def main(): url = "https://${GatewayEndpoint}/mcp" token = "your_bearer_token_here" tool_params = { "name": "LambdaTarget___get_order_tool", "arguments": { "orderId": "order123" } } await execute_mcp( url=url, token=token, tool_params=tool_params ) if __name__ == "__main__": asyncio.run(main())
Strands MCP Client

注: これはエージェントを呼び出すためのものです。

from strands.tools.mcp.mcp_client import MCPClient from mcp.client.streamable_http import streamablehttp_client def create_streamable_http_transport(mcp_url: str, access_token: str): return streamablehttp_client(mcp_url, headers={"Authorization": f"Bearer {access_token}"}) def run_agent(mcp_url: str, access_token: str): mcp_client = MCPClient(lambda: create_streamable_http_transport(mcp_url, access_token)) with mcp_client: result = mcp_client.call_tool_sync( tool_use_id="tool-123", # A unique ID for the tool call name="openapi-target-1___get_orders", # The name of the tool to invoke arguments={} # A dictionary of arguments for the tool ) print(result) url = {gatewayUrl} token = {AccessToken} run_agent(url, token)
LangGraph MCP Client

注: これはエージェントを呼び出すためのものです。

import asyncio from langgraph.prebuilt import create_react_agent def execute_agent( user_prompt, model_id, region, tools ): model = ChatBedrock(model_id=model_id, region_name=region) agent = create_react_agent(model, tools) _response = asyncio.run(agent.ainvoke({ "messages": user_prompt })) _response = _response.get('messages', {})[1].content print( f"Invoke Langchain Agents Response" f"Response - \n{_response}\n" ) return _response

エラー

tools/call オペレーションは、次のタイプのエラーを返すことができます。

  • HTTP ステータスコードの一部として返されるエラー:

    AuthenticationError

    認証情報が無効であるため、リクエストは失敗しました。

    HTTP ステータスコード: 401

    AuthorizationError

    呼び出し元にはツールを呼び出すアクセス許可がありません。

    HTTP ステータスコード: 403

    ResourceNotFoundError

    指定されたツールは存在しません。

    HTTP ステータスコード: 404

    ValidationError

    指定された引数は、ツールの入力スキーマに準拠していません。

    HTTP ステータスコード: 400

    ToolExecutionError

    ツールの実行中にエラーが発生しました。

    HTTP ステータスコード: 500

    InternalServerError

    内部サーバーエラーが発生しました。

    HTTP ステータスコード: 500

  • MCP エラー。これらのタイプのエラーの詳細については、Model Context Protocol (MCP) ドキュメントの「Error Handling」を参照してください。